//Tibbles
//Sourcecode, to be compiled with tigcc and tigcc-lib.
//Copyright 2000 Janne West (jwest@telia.com).
//Contact me if you got any questions, bugreports or suggestions.

#include <doors.h>
#include <all.h>

#define ARROWS_ROW 0xfffe
#define LEFT_KEY 2
#define RIGHT_KEY 8
#define UP_KEY 1
#define DOWN_KEY 4
#define ESC_ROW 0xffbf
#define ESC_KEY 1
#define pause GKeyFlush();ngetchx()
#define prgtitle "Tibbles"
#define lnum 26

int _ti89;
char _comment[] = "Tibbles by Janne West";

void Draw_Str(int x, int y, char *str);
void drawwindow(int x1, int y1, int x2, int y2, char *title);
void ScrRectInvert(int x1,int y1,int x2,int y2);
void startgame();
void rungame();
int moveworm(int lev);
void drawlev(int lev);
void drawworm();
void clearwormpos();
void placegoddie(int type);
void help();
void highscore();

static SCR_RECT draw_area ={0,0,159,100};

static BYTE levels[26][9][18]={{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,1,0,0,1,1,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,1,1,1,0,0,1,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1},
                                        {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
                                        {1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
                                        {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,4,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,4,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,0,0,0,0,0,0,0,0,4,4,4,4,4},
                                        {4,0,0,0,4,0,0,0,4,4,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,4,0,0,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,4,0,0,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,0,0,4,4,4,4,4,4,0,0,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,4,4,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,4,0,0,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,4,4,4,4,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,4,0,0,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,4,4,4,4,4,4,4,4,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,4},
                                        {4,4,4,4,4,0,0,0,0,0,0,0,0,4,4,4,4,4},
                                        {4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,4,0,0,4,4,4,0,0,4,0,0,0,0,4},
                                        {4,4,0,4,4,0,0,4,4,4,0,0,4,4,4,4,4,4},
                                        {4,0,0,0,4,0,0,4,4,4,0,0,4,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,0,0,0,0,0,0,4},
                                        {4,4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,4},
                                        {4,4,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4},
                                        {4,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4,4},
                                        {4,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,4,4},
                                        {4,0,0,0,0,0,0,4,4,4,4,4,4,4,4,4,4,4},
                                        {4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,5,0,0,5,5,5,0,5},
                                        {5,5,5,5,5,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,5,0,0,5,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,5,5,5,5,5},
                                        {5,0,5,5,5,0,0,5,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,5,0,5,0,5,5,0,5,0,5,0,0,0,5},
                                        {5,5,5,5,5,0,5,0,5,5,0,5,0,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,5,0,0,5,0,0,5,0,0,5,0,5},
                                        {5,0,0,5,0,0,5,0,0,5,0,0,5,0,0,5,0,5},
                                        {5,0,0,5,0,0,5,0,0,5,0,0,5,0,0,5,0,5},
                                        {5,0,0,5,0,0,5,0,0,5,0,0,5,0,0,5,0,5},
                                        {5,0,0,5,0,0,5,0,0,5,0,0,5,0,0,5,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,5,0,0,0,5,0,0,0,0,0,0,5},
                                        {5,0,0,5,5,5,5,0,0,0,5,5,5,5,0,0,5,5},
                                        {5,0,0,0,0,0,5,0,0,0,5,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,5,5,5,0,0,0,5},
                                        {5,0,0,0,5,0,5,0,0,0,0,5,0,0,0,0,0,5},
                                        {5,5,5,5,5,0,5,0,0,0,0,5,0,5,5,0,5,5},
                                        {5,0,0,0,0,0,5,0,0,0,0,0,0,5,0,0,0,5},
                                        {5,0,0,0,5,5,5,0,0,0,0,5,5,5,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,5},
                                        {5,0,5,5,5,5,5,5,5,0,5,5,5,5,5,5,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,5,5,5,5,5,5,5,0,5,5,5,5,5,5,0,5},
                                        {5,0,0,0,0,0,0,0,5,0,5,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}},
                                       {{5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,0,0,0,0,0,0,4,4,0,4,4,4,4,4,4,0,5},
                                        {5,0,4,0,0,0,0,0,0,0,0,0,0,0,0,4,0,5},
                                        {5,0,4,0,1,1,1,1,1,1,1,1,1,1,0,4,0,5},
                                        {5,0,4,0,0,0,0,0,0,0,0,0,0,0,0,4,0,5},
                                        {5,0,4,4,4,4,4,4,4,0,4,4,4,4,4,4,0,5},
                                        {5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5},
                                        {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}}};
unsigned int wormpos[9][18];

static unsigned int sprites[7][8]={{255,129,191,175,191,191,191,255}, //Wall
                                   { 24, 60,110,255,255,126, 60, 24}, //Worm
                                   { 60,126,207,223,255,255,126, 60}, //Goddie
                                   {255,129,189,189,189,189,129,255}, //Wall 2
                                   {255,255,235,181,145,133,129,255}, //Wall 3
                                   {  1,  7, 28,112,254, 28,112,192}, //Speedup
                                   { 60,194,177,145,153,141, 70, 60}};//Slowdown

static unsigned long logo[3][32]={{0,0,0,0,0,0,2031616,7864320,6325235,31965695,30195747,133742643,15778035,12611571,29361123,31458275,16762849,16762865,15722494,15200255,16510913,4185856,1966080,0,0,0,0,0,0,0,0,0},
                                  {0,0,0,0,0,0,1572870,1835015,491535,3758587919,3221684231,3339153415,2131228686,4279237647,3206544909,2267016973,121505560,2201880336,3464365628,4286455358,4267703359,268957724,28688,0,0,0,0,0,0,0,0,0},
                                  {0,0,0,0,0,0,0,0,0,0,31744,264371712,4293369792,4243034048,4244344800,4294639616,4163076352,2019590080,972288960,973076224,972154752,434237184,465698304,520093696,0,0,0,0,0,0,0,0}};


static unsigned int highscorescore[5][10]={{0,0,0,0,0,0,0,0,0,0},
                                            {0,0,0,0,0,0,0,0,0,0},
                                            {0,0,0,0,0,0,0,0,0,0},
                                            {0,0,0,0,0,0,0,0,0,0},
                                            {0,0,0,0,0,0,0,0,0,0}};

static char highscoreinit[5][10][4]={{{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0}},
                                     {{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0}},
                                     {{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0}},
                                     {{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0}},
                                     {{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0},{' ',' ',' ',0}}};

int opt[5]={1,1,1,3,0},optm[4]={lnum,5,2,5},dir,speedm,goddiep,round=1;
unsigned int wormlang,inclength;

static unsigned int tplayed=0;

LCD_BUFFER scr_empty,lev_scr;

void _main(void)
{
  int a,pos=0;
  char *text[4]={"New Game","High Score","Help","Exit"};
  char tmp[10];
  LCD_BUFFER buffer,buffer2;
  OSFreeTimer(6);
  OSRegisterTimer(6,1);
  LCD_save(buffer);
  ClearScreen();
  drawwindow(0,0,159,93,prgtitle);
  LCD_save(scr_empty);
  FontSetSys(F_6x8);
  for (a=0;a<=2;a++)
    Sprite32(32+a*32,10,32,logo[a],LCD_MEM,SPRT_OR);
  for (a=0;a<=3;a++)
    Draw_Str(53,40+a*12,text[a]);
  LCD_save(buffer2);
  do
  {
    a=0;
    LCD_restore(buffer2);
    sprintf(tmp,"%d",tplayed);
    FontSetSys(F_4x6);
    Draw_Str(150-DrawStrWidth(tmp,F_4x6),82,tmp);
    FontSetSys(F_6x8);
    Sprite16(30,40+12*pos,8,sprites[2],LCD_MEM,SPRT_OR);
    GKeyFlush();
    a=ngetchx();
    if (a==337) pos--;
    if (a==340) pos++;
    if (a==13)
    {
      if (pos==0)
        startgame();
      else if (pos==1)
        highscore(0,0);
      else if (pos==2)
        help();
      else if (pos==3)
        return;
    }
    if (pos<0) pos=3;
    if (pos>3) pos=0;
  } while (a!=264);
  LCD_restore(buffer);
}

void drawwindow(int x1, int y1, int x2, int y2, char *title)
{
  int a;
  SCR_RECT rect = {x1,y1,x2,y2};
  ScrRectFill(&rect,&draw_area,A_REVERSE);
  for (a=0;a<4;a++)
    if (a!=2) DrawClipRect(MakeWinRect(x1+a,y1+a,x2-a,y2-a),&draw_area,A_NORMAL);
  for (a=y1+4;a<y1+12;a++)
    DrawLine(x1+4,a,x2-4,a,A_NORMAL);
  FontSetSys(F_4x6);
  DrawStr(79-DrawStrWidth(title,F_4x6)/2,y1+5,title,A_REVERSE);
}

void startgame()
{
  int a,b,pos=0;
  LCD_BUFFER buffer;
  opt[0]=opt[2]=1;
  opt[1]=opt[3]=3;
  drawwindow(30,28,129,77,"Start game");
  FontSetSys(F_4x6);
  DrawStr(34,42,"Start at level",A_NORMAL);
  DrawStr(34,50,"Starting lives",A_NORMAL);
  DrawStr(34,58,"Level order",A_NORMAL);
  DrawStr(34,66,"Speed",A_NORMAL);
  for (a=42;a<=66;a+=8)
  {
    DrawStr(85,a,"<",A_NORMAL);
    DrawStr(120,a,">",A_NORMAL);
  }
  LCD_save(buffer);
  do
  {
    LCD_restore(buffer);
    printf_xy(104-(opt[0]>9?4:2),42,"%d",opt[0]);
    printf_xy(102,50,"%d",opt[1]);
    printf_xy(92,58,opt[2]==1?"Normal":"Random");
    printf_xy(102,66,"%d",opt[3]);
    ScrRectInvert(85,41+8*pos,124,47+8*pos);
    GKeyFlush();
    a=ngetchx();
    if (a==337) pos--;
    if (a==340) pos++;
    if (pos<0) pos=3;
    if (pos>3) pos=0;
    if (a==338) opt[pos]--;
    if (a==344) opt[pos]++;
    for (b=0;b<4;b++)
    {
      opt[b]=opt[b]>optm[b]?optm[b]:opt[b];
      opt[b]=opt[b]<1?1:opt[b];
    }
  } while (a!=264 && a!=13);
  if (a==264) return;
  opt[3]=6-opt[3];
  rungame();
}

void ScrRectInvert(int x1,int y1,int x2,int y2)
{
  SCR_RECT rect = {x1,y1,x2,y2};
  ScrRectFill(&rect,&draw_area,A_XOR);
}

void help()
{
  int i;
  char *helptext[14]={prgtitle,"by Janne West","alazorn@hotmail.com","(www.alazorn.org)","---------------------------",
                     "The objectives of this game","is to pick up 7 pices of food on","each of the 26 levels",
                     "without running into the wall.","Wall","You","Food","Speedup","Slowdown"};
  drawwindow(20,4,139,94,"Help");
  for (i=0;i<=8;i++)
    Draw_Str(79-DrawStrWidth(helptext[i],F_4x6)/2,19+i*8,helptext[i]);
  pause;
  drawwindow(20,4,139,94,"Help");
  for (i=9;i<=13;i++)
    Draw_Str(60,21+(i-9)*10,helptext[i]);
  for (i=0;i<=2;i++)
    Sprite16(20+i*10,19,8,sprites[i>=1?i+2:0],LCD_MEM,SPRT_OR);
  for (i=0;i<=3;i++)
    Sprite16(20,29+i*10,8,sprites[i<=1?i+1:i+3],LCD_MEM,SPRT_OR);
  pause;
}

void rungame()
{
  SCR_RECT rect = {10,86,149,92};
  int a,b,goddiec,x=2,y=2,nothit=1,done,levp,score=0,speed=0,run=0,i,key;
  char str[6];
  str[0]=0;
  opt[4]=0;
  done=0;
  levp=0;
  round=0;
  speed=opt[3];
  tplayed++;
  do
  {
    wormlang=1;
    inclength=3;
    goddiec=0;
    nothit=1;
    speedm=0;
    goddiep=0;
    dir=RIGHT_KEY;
    clearwormpos();
    LCD_restore(scr_empty);
    ScrRectFill(&rect,&draw_area,A_REVERSE);
    for (a=9;a<=151;a+=141)
      DrawPix(a,91,A_NORMAL);
    for (a=0;a<=1;a++)
      wormpos[a][0]=2;
    drawlev(opt[0]-1);
    placegoddie(0);
    ScrRectFill(&rect,&draw_area,A_REVERSE);
    GKeyFlush();
    while (nothit && goddiec<7)
    {
      GKeyFlush();
      for (a=0;a<(opt[3]+speedm<1?1:opt[3]+speedm);a++)
      {
        while (!OSTimerExpired(6));
        OSTimerRestart(6);
        if (_rowread(ESC_ROW)&ESC_KEY)
        {
          ScrRectFill(&rect,&draw_area,A_REVERSE);
          Draw_Str(11,87,"Paused, ESC to exit ENTER to continue");
          b=0;
          while (b!=13 && b!=264)
          {
            GKeyFlush();
            b=ngetchx();
          }
          GKeyFlush();
          ScrRectFill(&rect,&draw_area,A_REVERSE);
          if (b==264) return;
        }
        if (_rowread(ARROWS_ROW)&LEFT_KEY)
        {
          if (dir!=RIGHT_KEY)
            dir=LEFT_KEY;
        }
        else if (_rowread(ARROWS_ROW)&RIGHT_KEY)
        {
          if (dir!=LEFT_KEY)
            dir=RIGHT_KEY;
        }
        else if (_rowread(ARROWS_ROW)&DOWN_KEY)
        {
          if (dir!=UP_KEY)
            dir=DOWN_KEY;
        }
        else if (_rowread(ARROWS_ROW)&UP_KEY)
        {
          if (dir!=DOWN_KEY)
            dir=UP_KEY;
        }
      }
      printf_xy(11,87,opt[2]!=1?"Level : Rnd":"Level : %d-%d", round, opt[0]);
      printf_xy(56,87,"Lives : %d", opt[1]);
      printf_xy(94,87,"Score : %d", opt[4]);
      nothit=moveworm(opt[0]-1);
      drawworm();
      randomize();
      if (rand()%100>50 && !goddiep) placegoddie(1);
      if (nothit==2)
      {
        goddiec++;
        placegoddie(0);
        opt[4]++;
      }
      if (inclength>0)
      {
        inclength--;
        wormlang++;
      }
    }
    if (opt[1]>=1 && !done)
    {
      drawwindow(20,25,139,55,"Start");
      Draw_Str(25,38,!nothit?"You died":"Level completed");
      Draw_Str(25,46,"Press ENTER to continue");
      GKeyFlush();
    }
    while (a!=13)
    {
      GKeyFlush();
      a=ngetchx();
    }
    if (!nothit)
    {
      opt[1]--;
    } else
    {
      if (opt[2]==1)
        opt[0]++;
      else
      {
        randomize();
        opt[0]=rand()%lnum;
        levp++;
      }
    }
    if (opt[1]<=0) done=1;
    if (opt[0]>lnum || levp>=lnum)
    {
      opt[0]=1;
      opt[3]--;
      if (opt[3]<1) opt[3]=1;
      round++;
      levp=0;
    }
  } while (opt[1]>=1 && !done);
  score=opt[4];
  for (a=0;a<9;a++)
  {
    if (score>highscorescore[speed-1][a] && !run)
    {
      for (b=8;b>=a;b--)
      {
        highscorescore[speed-1][b+1]=highscorescore[speed-1][b];
        for (i=0;i<=3;i++)
          highscoreinit[speed-1][b+1][i]=highscoreinit[speed-1][b][i];
      }
      drawwindow(20,25,139,65,"High Score");
      Draw_Str(25,39,"You have got a new High Score");
      Draw_Str(25,47,"Enter your inititals :");
      GKeyFlush();
      i=0;
      while(key!=13)
      {
        str[i]='_'; str[i+1]=0;
        for (y=0;y<7;y++)
          DrawLine(25,54+y,55,54+y,A_REVERSE);
        Draw_Str(25,55,str);
        key=ngetchx();
        if(key>=' '&&key<='~'&&i<3) str[i++]=key;
          if(key==257&&i) i--;
      }
      str[i]=0;
      highscorescore[speed-1][a]=score;
      for (i=0;i<=3;i++)
        highscoreinit[speed-1][a][i]=str[i];
      run=1;
    }
  }
  return;
}

void drawlev(int lev)
{
  int x,y;
  for (x=0;x<=17;x++)
  {
    for (y=0;y<=8;y++)
    {
      if (levels[lev][y][x]>0)
        Sprite16(x*8,14+y*8,8,sprites[levels[lev][y][x]-1],LCD_MEM,SPRT_OR);
    }
  }
  LCD_save(lev_scr);
}

void drawworm()
{
  int x,y,a;
  for (x=1;x<=17;x++)
  {
    for (y=1;y<=8;y++)
    {
      a=0;
      if (wormpos[y][x]>0)
        Sprite16(8*x,14+8*y,8,sprites[1],LCD_MEM,SPRT_OR);
      if (levels[opt[0]-1][y][x]==21)
        a=2;
      else if (levels[opt[0]-1][y][x]==22)
        a=5;
      else if (levels[opt[0]-1][y][x]==23)
        a=6;
      if (a>0 && a<=6) Sprite16(8*x,14+8*y,8,sprites[a],LCD_MEM,SPRT_OR);
    }
  }
}

int moveworm(int lev)
{
  int x,y,done,goddiet;
  done=0;
  goddiet=1;
  for (x=1;x<=17;x++)
  {
    for (y=1;y<=8;y++)
    {
      if (wormpos[y][x]==1 && !done)
      {
        wormpos[y][x]++;
        done=1;
        if (dir==UP_KEY)
        {
          if (wormpos[y-1][x]==0 && (levels[opt[0]-1][y-1][x]==0 || levels[opt[0]-1][y-1][x]>20))
            wormpos[y-1][x]=1;
          else return 0;
        }
        if (dir==DOWN_KEY)
        {
          if (wormpos[y+1][x]==0 && (levels[opt[0]-1][y+1][x]==0 || levels[opt[0]-1][y+1][x]>20))
            wormpos[y+1][x]=1;
          else return 0;
        }
        if (dir==RIGHT_KEY)
        {
          if (wormpos[y][x+1]==0 && (levels[opt[0]-1][y][x+1]==0 || levels[opt[0]-1][y][x+1]>20))
            wormpos[y][x+1]=1;
          else return 0;
        }
        if (dir==LEFT_KEY)
        {
          if (wormpos[y][x-1]==0 && (levels[opt[0]-1][y][x-1]==0 || levels[opt[0]-1][y][x-1]>20))
            wormpos[y][x-1]=1;
          else return 0;
        }
      } else if (wormpos[y][x]>1) wormpos[y][x]++;
    }
  }
  for (x=1;x<=16;x++)
  {
    for (y=1;y<=7;y++)
    {
      if (wormpos[y][x]==wormlang+1 && !inclength)
      {
        wormpos[y][x]=0;
        Sprite16(8*x,14+8*y,8,sprites[1],LCD_MEM,SPRT_XOR);
      } else
      if (wormpos[y][x]==1)
      {
        if (levels[lev][y][x]==21)
        {
          inclength+=2;
          Sprite16(8*x,14+8*y,8,sprites[2],LCD_MEM,SPRT_XOR);
          goddiet=2;
        } else if (levels[lev][y][x]==22)
        {
          speedm-=1;
          Sprite16(8*x,14+8*y,8,sprites[5],LCD_MEM,SPRT_XOR);
        } else if (levels[lev][y][x]==23)
        {
          speedm+=1;
          Sprite16(8*x,14+8*y,8,sprites[6],LCD_MEM,SPRT_XOR);
        }
        if (levels[lev][y][x]>21)
          goddiep=0;
        if (levels[lev][y][x]>20)
          levels[lev][y][x]=0;
      }
    }
  }
  return goddiet;
}

void clearwormpos()
{
  int x,y;
  for (x=0;x<=17;x++)
  {
    for (y=0;y<=8;y++)
    {
      wormpos[y][x]=0;
      if (levels[opt[0]-1][y][x]>20) levels[opt[0]-1][y][x]=0;
    }
  }
  wormpos[2][2]=1;
}

void placegoddie(int type)
{
  int x,y,a;
  do
  {
    randomize();
    x=(rand()%15)+1;
    y=(rand()%6)+1;
  } while (levels[opt[0]-1][y][x]>0 || wormpos[y][x]>0 || wormpos[y+1][x]>0 || wormpos[y-1][x]>0 || wormpos[y][x+1]>0 || wormpos[y][x-1]>0);
  if (!type)
    levels[opt[0]-1][y][x]=21;
  else
  {
    randomize();
    a=rand()%3;
    if (a==1)
      levels[opt[0]-1][y][x]=22;
    else if (a==2)
      levels[opt[0]-1][y][x]=23;
    goddiep=1;
  }
}

void highscore()
{
  int i=0,key=0,y,a,b;
  char tmp[50];
  LCD_BUFFER buffer;
  b=1;
  a=0;
  drawwindow(30,0,129,93,"High Score");
  FontSetSys(F_4x6);
  Draw_Str(41,14,"Speed :");
  Draw_Str(75,14,"<");
  Draw_Str(110,14,">");
  Draw_Str(58,22,"Initials");
  Draw_Str(104,22,"Score");
  DrawLine(36,28,123,28,A_NORMAL);
  tmp[0]=0;
  for (i=1;i<=10;i++)
  {
    sprintf(tmp,"%d",i);
    printf_xy(46-DrawStrWidth(tmp,F_4x6),24+6*i,"%d.",i);
  }
  LCD_save(buffer);
  while (a!=264)
  {
    a=0;
    LCD_restore(buffer);
    printf_xy(92,14,"%d",b);
    ScrRectInvert(75,13,114,19);
    for (i=0;i<=9;i++)
    {
      Draw_Str(58,30+i*6,highscoreinit[5-b][i]);
      sprintf(tmp,"%d",highscorescore[5-b][i]);
      printf_xy(123-DrawStrWidth(tmp,F_4x6),30+i*6,"%d",highscorescore[5-b][i]);
    }
    GKeyFlush();
    a=ngetchx();
    if (a==338) b--;
    if (a==344) b++;
    if (b>5) b=1;
    if (b<1) b=5;
  }
}

void Draw_Str(int x, int y, char *str)
{
  DrawStr(x,y,str,A_NORMAL);
}
